package org.processmining.glueminer.dialogs;

import javax.swing.JComponent;

import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;
import org.processmining.glueminer.parameters.LogGeneratorConstants;
import org.processmining.glueminer.parameters.LogGeneratorParameters;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

import com.fluxicon.slickerbox.components.NiceDoubleSlider;
import com.fluxicon.slickerbox.components.NiceIntegerSlider;
import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class LogGeneratorPluginWizardStep extends ProMPropertiesPanel implements ProMWizardStep<LogGeneratorParameters> {
	/*
	 * 	public Integer wantedTraces;
	public Double prUncompleteness;
	public Double prSkipping;
	public Double prInserting;
	public Integer maxTraceLength;
	 */
	
	NiceIntegerSlider sliderWantedTraces;
	NiceDoubleSlider sliderPrUncompleteness;
	NiceDoubleSlider sliderPrSkipping;
	NiceDoubleSlider sliderPrInserting;
	NiceIntegerSlider sliderMaxTraceLength;
	
	public LogGeneratorPluginWizardStep(String title) {
		super(title);
		// TODO Auto-generated constructor stub
		
	}

	public static String TITLE = "Configure Log Generator Plugin wizard step";
	
	public LogGeneratorPluginWizardStep(Petrinet net) {
		super(TITLE);
		
		this.sliderWantedTraces = SlickerFactory.instance().createNiceIntegerSlider("Number of wanted output traces", LogGeneratorConstants.minWantedTraces, LogGeneratorConstants.maxWantedTraces, LogGeneratorConstants.defaultWantedTraces, Orientation.HORIZONTAL);
		this.sliderPrUncompleteness = SlickerFactory.instance().createNiceDoubleSlider("Probability of uncompleteness", LogGeneratorConstants.minPrUncompleteness, LogGeneratorConstants.maxPrUncompleteness, LogGeneratorConstants.defaultPrUncompleteness, Orientation.HORIZONTAL);
		this.sliderPrSkipping = SlickerFactory.instance().createNiceDoubleSlider("Probability of skipping", LogGeneratorConstants.minPrSkipping, LogGeneratorConstants.maxPrSkipping, LogGeneratorConstants.defaultPrSkipping, Orientation.HORIZONTAL);
		this.sliderPrInserting = SlickerFactory.instance().createNiceDoubleSlider("Probability of inserting", LogGeneratorConstants.minPrInserting, LogGeneratorConstants.maxPrInserting, LogGeneratorConstants.defaultPrInserting, Orientation.HORIZONTAL);
		this.sliderMaxTraceLength = SlickerFactory.instance().createNiceIntegerSlider("Max (event) length of a single trace", LogGeneratorConstants.minMaxTraceLength, LogGeneratorConstants.maxMaxTraceLength, LogGeneratorConstants.defaultMaxTraceLength, Orientation.HORIZONTAL);
		
		this.add(this.sliderWantedTraces);
		this.add(this.sliderPrUncompleteness);
		this.add(this.sliderPrSkipping);
		this.add(this.sliderPrInserting);
		this.add(this.sliderMaxTraceLength);
	}

	public LogGeneratorParameters apply(LogGeneratorParameters model, JComponent component) {
		// TODO Auto-generated method stub
		LogGeneratorParameters parameters = new LogGeneratorParameters(this.sliderWantedTraces.getValue(), this.sliderPrUncompleteness.getValue(), this.sliderPrSkipping.getValue(), this.sliderPrInserting.getValue(), this.sliderMaxTraceLength.getValue());

		return parameters;
	}

	public boolean canApply(LogGeneratorParameters model, JComponent component) {
		// TODO Auto-generated method stub
		return true;
	}

	public JComponent getComponent(LogGeneratorParameters model) {
		// TODO Auto-generated method stub
		return this;
	}

	public String getTitle() {
		// TODO Auto-generated method stub
		return TITLE;
	}
}
